Setting Live Bing ‘Search Volume History’ Tasks

‌This endpoint will provide you with historical search volume data for up to 1000 keywords in one request. You can get search volume for keywords in monthly, weekly, or daily format and specify the device type.

If your system requires delivering instant results, the Live method is the best solution for you. Unlike the Standard method, this method doesn’t require making separate POST and GET requests to the corresponding endpoints.

If you don’t need to receive data in real-time, you can use the Standard method of data retrieval. This method requires making separate POST and GET requests, but it’s more affordable. Using this method you can retrieve the results after our system collects them.

Historical data is available for 24 months.

checked POST
Pricing

Your account will be charged for each request.
The cost can be calculated on the Pricing page.

All POST data should be sent in the JSON format (UTF-8 encoding). The task setting is done using the POST method. When setting a task, you should send all task parameters in the task array of the generic POST array. You can send up to 2000 API calls per minute, each Live API call can contain only one task.. Visit DataForSEO Help Center to get practical tips for request handling depending on your Keyword Data API payload volume.

You will get information for every single keyword in an array.

You can send up to 1000 keywords in one keywords array. Our system will charge your account per each request, no matter what number of keywords an array has, the price for 1 or 1000 keywords will be the same.

Below you will find a detailed description of the fields you can use for setting a task.

Description of the fields for setting a task:

Field nameTypeDescription
keywordsarray

keywords
required field
The maximum number of keywords you can specify: 1000
The maximum number of characters for each keyword: 100
the specified keywords will be converted to lowercase, data will be provided in a separate arraylearn more about rules and limitations of keyword and keywords fields in DataForSEO APIs in this Help Center article

location_namestring

full name of search engine location
required field if you don't specify location_code or location_coordinate
if you use this field, you don't need to specify location_code or location_coordinate
you can receive the list of available locations of the search engine with their location_name by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/locations_and_languages
example:
London,England,United Kingdom

location_codeinteger

search engine location code
required field if you don't specify location_name or location_coordinate
if you use this field, you don't need to specify location_name or location_coordinate
you can receive the list of available locations of the search engines with their location_code by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/locations_and_languages
example:
2840

location_coordinatestring

GPS coordinates of a location
required field if you don't specify location_name or location_code
if you use this field, you don't need to specify location_name or location_code
location_coordinate parameter should be specified in the "latitude,longitude" format
the data will be provided for the country the specified coordinates belong to
example:
52.6178549,-155.352142

language_namestring

full name of search engine language
required field if you don't specify language_code
if you use this field, you don't need to specify language_code
you can receive the list of available languages of the search engines with their language_code by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/locations_and_languages

language_codestring

search engine language code
required field if you don't specify language_name
if you use this field, you don't need to specify language_name
you can receive the list of available languages of the search engines with their language_code by making a separate request to https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/locations_and_languages

devicearray

device types
optional field
specify this field if you want to get the data for a particular device types
possible values: mobile, desktop, tablet, non_smartphones
default value: ["mobile", "desktop", "tablet", "non_smartphones"]

periodstring

aggregates the returned data to a certain time period
optional field
specify this field if you want to get the data in monthly, weekly or daily formatpossible values: monthly, weekly, daily

monthly - returns data up to past 24 months
weekly - returns data up to past 15 weeks
daily - returns data up to past 45 days

default value: monthly

date_fromstring

starting date of the time range
optional field
minimum value: 24 months back from today’s date;
if Status endpoint returns false in the actual_data field, date_from can be set to the month before last and prior;
if Status endpoint returns true in the actual_data field, date_from can be set to the last month and prior;

date format: "yyyy-mm-dd"
example:
"2020-01-01"Note: we do not recommend using a custom time range;

Note 2: if date_from and date_to parameters are not specified, the data will be returned for the past 24 months;

if you specify the period parameter:

with value weekly, you will get results for the past 15 weeks;
with value daily, you will get results for the past 45 days

date_tostring

ending date of the time range
optional fieldminimum value: two years back from today’s date;
maximum value: one day from today's date;
date format: "yyyy-mm-dd"
example:
"2020-03-15"

Note: we do not recommend using a custom time range

Note 2: if date_from and date_to parameters are not specified, the data will be returned for the past 24 months

if you specify the period parameter:

with value weekly, you will get results for the past 15 weeks
with value daily, you will get results for the past 45 days

tagstring

user-defined task identifier
optional field
the character limit is 255
you can use this parameter to identify the task and match it with the result
you will find the specified tag value in the data object of the response


As a response of the API server, you will receive JSON-encoded data containing a tasks array with the information specific to the set tasks.

Description of the fields in the results array:

Field nameTypeDescription
versionstring

the current version of the API

status_codeinteger

general status code
you can find the full list of the response codes here
Note: we strongly recommend designing a necessary system for handling related exceptional or error conditions

status_messagestring

general informational message
you can find the full list of general informational messages here

timestring

execution time, seconds

costfloat

total tasks cost, USD

tasks_countinteger

the number of tasks in the tasks array

tasks_errorinteger

the number of tasks in the tasks array returned with an error

tasksarray

array of tasks

    idstring

task identifier
unique task identifier in our system in the UUID format

    status_codeinteger

status code of the task
generated by DataForSEO; can be within the following range: 10000-60000
you can find the full list of response codes here

    status_messagestring

informational message of the task
you can find the full list of general informational messages here

    timestring

execution time, seconds

    costfloat

cost of the task, USD

    result_countinteger

number of elements in the result array

    patharray

URL path

    dataobject

contains the same parameters that you specified in the POST request

    resultarray

array of results

        keywordstring

keyword in a POST array

        location_codeinteger

location code in a POST array
if there is no data, then the value is_nulln

        language_codestring

language code in a POST array
if there is no data, then the value is_nulln

        devicestring

device type in a POST array
if there is no data, then the value is_nulln

        periodstring

time period
indicates if returned data is aggregated to a certain time period
default value monthly

        searchesobject

contains results distributed by device type
if the device parameter is not specified, the data will be returned for all available device types

            desktopobject

device type = desktop
contains historical search volume data for searches made from desktop devices

                yearinteger

year

                monthinteger

month

                dayinteger

day of the month

                search_volumeinteger

search volume rate

            non_smartphonesobject

device type = non-smartphones
contains historical search volume data for searches made from feature phones (non-smartphone mobile devices)

                yearinteger

year

                monthinteger

month

                dayinteger

day of the month

                search_volumeinteger

search volume rate

            mobileobject

device type = mobile
contains historical search volume data for searches made from mobile devices

                yearinteger

year

                monthinteger

month

                dayinteger

day of the month

                search_volumeinteger

search volume rate

            tabletobject

device type = tablet
contains historical search volume data for searches made from tablets

                yearinteger

year

                monthinteger

month

                dayinteger

day of the month

                search_volumeinteger

search volume rate


‌‌

Instead of ‘login’ and ‘password’ use your credentials from https://app.dataforseo.com/api-access

# Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access 
login="login" 
password="password" 
cred="$(printf ${login}:${password} | base64)" 
curl --location --request POST "https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/live" 
--header "Authorization: Basic ${cred}"  
--header "Content-Type: application/json" 
--data-raw '[
  {
    "location_code": 2840,
    "language_code": "en",
    "keywords": [
      "10 minute timer"
    ]
  }
]'
<?php
// You can download this file from here https://cdn.dataforseo.com/v3/examples/php/php_RestClient.zip
require('RestClient.php');
$api_url = 'https://api.dataforseo.com/';
// Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
$client = new RestClient($api_url, null, 'login', 'password');
$post_array = array();
// simple way to set a task
$post_array[] = array(
    "location_name" => "United States",
    "language_name" => "English",
    "keywords" => array(
        "average page rpm adsense",
        "adsense blank ads how long",
        "leads and prospects"
    )
);
try {
    // POST /v3/keywords_data/bing/search_volume_history/live
    // the full list of possible parameters is available in documentation
    $result = $client->post('/v3/keywords_data/bing/search_volume_history/live', $post_array);
    print_r($result);
    // do something with post result
} catch (RestClientException $e) {
    echo "n";
    print "HTTP code: {$e->getHttpCode()}n";
    print "Error code: {$e->getCode()}n";
    print "Message: {$e->getMessage()}n";
    print $e->getTraceAsString();
    echo "n";
}
$client = null;
?>
var request = require('request');
var options = {
  'method': 'POST',
  'url': 'https://api.dataforseo.com/v3/keywords_data/bing/search_volume_history/live',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': '••••••'
  },
  body: JSON.stringify([
    {
      "location_code": 2840,
      "language_code": "en",
      "keywords": [
        "10 minute timer"
      ]
    }
  ])

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
from client import RestClient
# You can download this file from here https://cdn.dataforseo.com/v3/examples/python/python_Client.zip
client = RestClient("login", "password")
post_data = dict()
# simple way to set a task
post_data[len(post_data)] = dict(
    location_name="United States",
    language_name="English",
    keywords=[
        "average page rpm adsense",
        "adsense blank ads how long",
        "leads and prospects"
    ]
)
# POST /v3/keywords_data/bing/search_volume_history/live
# the full list of possible parameters is available in documentation
response = client.post("/v3/keywords_data/bing/search_volume_history/live", post_data)
# you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
if response["status_code"] == 20000:
    print(response)
    # do something with result
else:
    print("error. Code: %d Message: %s" % (response["status_code"], response["status_message"]))
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;
namespace DataForSeoDemo
{
    public static partial class Demos
    {
        public static async Task keywords_data_search_volume_history_live()
        {
            var httpClient = new HttpClient
            {
                BaseAddress = new Uri("https://api.dataforseo.com/"),
                // Instead of 'login' and 'password' use your credentials from https://app.dataforseo.com/api-access
                DefaultRequestHeaders = { Authorization = new AuthenticationHeaderValue("Basic",
                    Convert.ToBase64String(Encoding.ASCII.GetBytes("login:password"))) }
            };
            var postData = new List<object>();
            postData.Add(new
            {
                location_name = "United States",
                language_name = "English",
                keywords = new[]
                {
                    "average page rpm adsense",
                    "adsense blank ads how long",
                    "leads and prospects"
                }
            });
            // POST /v3/keywords_data/bing/search_volume_history/live
            // the full list of possible parameters is available in documentation
            var taskPostResponse = await httpClient.PostAsync("/v3/keywords_data/bing/search_volume_history/live", new
                StringContent(JsonConvert.SerializeObject(postData)));
            var result = JsonConvert.DeserializeObject<dynamic>(await taskPostResponse.Content.ReadAsStringAsync());
            // you can find the full list of the response codes here https://docs.dataforseo.com/v3/appendix/errors
            if (result.status_code == 20000)
            {
                // do something with result
                Console.WriteLine(result);
            }
            else
                Console.WriteLine($"error. Code: {result.status_code} Message: {result.status_message}");
        }
    }
}

The above command returns JSON structured like this:

{
  "version": "0.1.20240626",
  "status_code": 20000,
  "status_message": "Ok.",
  "time": "12.9494 sec.",
  "cost": 0.075,
  "tasks_count": 1,
  "tasks_error": 0,
  "tasks": [
    {
      "id": "07091833-1535-0262-0000-8c3e7e69bcac",
      "status_code": 20000,
      "status_message": "Ok.",
      "time": "12.8860 sec.",
      "cost": 0.075,
      "result_count": 1,
      "path": [
        "v3",
        "keywords_data",
        "bing",
        "search_volume_history",
        "live"
      ],
      "data": {
        "api": "keywords_data",
        "function": "search_volume_history",
        "se": "bing",
        "location_code": 2840,
        "language_code": "en",
        "keywords": [
          "10 minute timer"
        ]
      },
      "result": [
        {
          "keyword": "10 minute timer",
          "location_code": 2840,
          "language_code": "en",
          "device": [
            "desktop",
            "non_smartphones",
            "mobile",
            "tablet"
          ],
          "period": "monthly",
          "searches": {
            "desktop": [
              {
                "year": 2024,
                "month": 6,
                "day": 1,
                "search_volume": 19137
              },
              {
                "year": 2024,
                "month": 5,
                "day": 1,
                "search_volume": 30887
              },
              {
                "year": 2024,
                "month": 4,
                "day": 1,
                "search_volume": 36423
              },
              {
                "year": 2024,
                "month": 3,
                "day": 1,
                "search_volume": 51340
              },
              {
                "year": 2024,
                "month": 2,
                "day": 1,
                "search_volume": 66649
              },
              {
                "year": 2024,
                "month": 1,
                "day": 1,
                "search_volume": 74974
              },
              {
                "year": 2023,
                "month": 12,
                "day": 1,
                "search_volume": 66793
              },
              {
                "year": 2023,
                "month": 11,
                "day": 1,
                "search_volume": 75869
              },
              {
                "year": 2023,
                "month": 10,
                "day": 1,
                "search_volume": 76204
              },
              {
                "year": 2023,
                "month": 9,
                "day": 1,
                "search_volume": 58507
              },
              {
                "year": 2023,
                "month": 8,
                "day": 1,
                "search_volume": 38496
              },
              {
                "year": 2023,
                "month": 7,
                "day": 1,
                "search_volume": 29263
              },
              {
                "year": 2023,
                "month": 6,
                "day": 1,
                "search_volume": 32979
              },
              {
                "year": 2023,
                "month": 5,
                "day": 1,
                "search_volume": 36368
              },
              {
                "year": 2023,
                "month": 4,
                "day": 1,
                "search_volume": 37556
              },
              {
                "year": 2023,
                "month": 3,
                "day": 1,
                "search_volume": 43481
              },
              {
                "year": 2023,
                "month": 2,
                "day": 1,
                "search_volume": 39389
              },
              {
                "year": 2023,
                "month": 1,
                "day": 1,
                "search_volume": 42348
              },
              {
                "year": 2022,
                "month": 12,
                "day": 1,
                "search_volume": 39122
              },
              {
                "year": 2022,
                "month": 11,
                "day": 1,
                "search_volume": 40490
              },
              {
                "year": 2022,
                "month": 10,
                "day": 1,
                "search_volume": 38987
              },
              {
                "year": 2022,
                "month": 9,
                "day": 1,
                "search_volume": 38622
              },
              {
                "year": 2022,
                "month": 8,
                "day": 1,
                "search_volume": 30143
              },
              {
                "year": 2022,
                "month": 7,
                "day": 1,
                "search_volume": 23803
              }
            ],
            "non_smartphones": [
              {
                "year": 2023,
                "month": 9,
                "day": 1,
                "search_volume": 1
              },
              {
                "year": 2023,
                "month": 7,
                "day": 1,
                "search_volume": 2
              },
              {
                "year": 2023,
                "month": 6,
                "day": 1,
                "search_volume": 2
              },
              {
                "year": 2023,
                "month": 5,
                "day": 1,
                "search_volume": 2
              },
              {
                "year": 2023,
                "month": 4,
                "day": 1,
                "search_volume": 1
              },
              {
                "year": 2023,
                "month": 3,
                "day": 1,
                "search_volume": 3
              },
              {
                "year": 2023,
                "month": 2,
                "day": 1,
                "search_volume": 3
              },
              {
                "year": 2023,
                "month": 1,
                "day": 1,
                "search_volume": 1
              },
              {
                "year": 2022,
                "month": 7,
                "day": 1,
                "search_volume": 1
              }
            ],
            "mobile": [
              {
                "year": 2024,
                "month": 6,
                "day": 1,
                "search_volume": 1046
              },
              {
                "year": 2024,
                "month": 5,
                "day": 1,
                "search_volume": 1090
              },
              {
                "year": 2024,
                "month": 4,
                "day": 1,
                "search_volume": 970
              },
              {
                "year": 2024,
                "month": 3,
                "day": 1,
                "search_volume": 1554
              },
              {
                "year": 2024,
                "month": 2,
                "day": 1,
                "search_volume": 1300
              },
              {
                "year": 2024,
                "month": 1,
                "day": 1,
                "search_volume": 1657
              },
              {
                "year": 2023,
                "month": 12,
                "day": 1,
                "search_volume": 1787
              },
              {
                "year": 2023,
                "month": 11,
                "day": 1,
                "search_volume": 1680
              },
              {
                "year": 2023,
                "month": 10,
                "day": 1,
                "search_volume": 1935
              },
              {
                "year": 2023,
                "month": 9,
                "day": 1,
                "search_volume": 1880
              },
              {
                "year": 2023,
                "month": 8,
                "day": 1,
                "search_volume": 1813
              },
              {
                "year": 2023,
                "month": 7,
                "day": 1,
                "search_volume": 1192
              },
              {
                "year": 2023,
                "month": 6,
                "day": 1,
                "search_volume": 1555
              },
              {
                "year": 2023,
                "month": 5,
                "day": 1,
                "search_volume": 1331
              },
              {
                "year": 2023,
                "month": 4,
                "day": 1,
                "search_volume": 1184
              },
              {
                "year": 2023,
                "month": 3,
                "day": 1,
                "search_volume": 1186
              },
              {
                "year": 2023,
                "month": 2,
                "day": 1,
                "search_volume": 852
              },
              {
                "year": 2023,
                "month": 1,
                "day": 1,
                "search_volume": 1153
              },
              {
                "year": 2022,
                "month": 12,
                "day": 1,
                "search_volume": 1641
              },
              {
                "year": 2022,
                "month": 11,
                "day": 1,
                "search_volume": 1781
              },
              {
                "year": 2022,
                "month": 10,
                "day": 1,
                "search_volume": 2883
              },
              {
                "year": 2022,
                "month": 9,
                "day": 1,
                "search_volume": 2408
              },
              {
                "year": 2022,
                "month": 8,
                "day": 1,
                "search_volume": 1658
              },
              {
                "year": 2022,
                "month": 7,
                "day": 1,
                "search_volume": 1332
              }
            ],
            "tablet": [
              {
                "year": 2024,
                "month": 6,
                "day": 1,
                "search_volume": 750
              },
              {
                "year": 2024,
                "month": 5,
                "day": 1,
                "search_volume": 616
              },
              {
                "year": 2024,
                "month": 4,
                "day": 1,
                "search_volume": 627
              },
              {
                "year": 2024,
                "month": 3,
                "day": 1,
                "search_volume": 814
              },
              {
                "year": 2024,
                "month": 2,
                "day": 1,
                "search_volume": 731
              },
              {
                "year": 2024,
                "month": 1,
                "day": 1,
                "search_volume": 804
              },
              {
                "year": 2023,
                "month": 12,
                "day": 1,
                "search_volume": 769
              },
              {
                "year": 2023,
                "month": 11,
                "day": 1,
                "search_volume": 670
              },
              {
                "year": 2023,
                "month": 10,
                "day": 1,
                "search_volume": 712
              },
              {
                "year": 2023,
                "month": 9,
                "day": 1,
                "search_volume": 602
              },
              {
                "year": 2023,
                "month": 8,
                "day": 1,
                "search_volume": 609
              },
              {
                "year": 2023,
                "month": 7,
                "day": 1,
                "search_volume": 695
              },
              {
                "year": 2023,
                "month": 6,
                "day": 1,
                "search_volume": 815
              },
              {
                "year": 2023,
                "month": 5,
                "day": 1,
                "search_volume": 730
              },
              {
                "year": 2023,
                "month": 4,
                "day": 1,
                "search_volume": 709
              },
              {
                "year": 2023,
                "month": 3,
                "day": 1,
                "search_volume": 747
              },
              {
                "year": 2023,
                "month": 2,
                "day": 1,
                "search_volume": 647
              },
              {
                "year": 2023,
                "month": 1,
                "day": 1,
                "search_volume": 779
              },
              {
                "year": 2022,
                "month": 12,
                "day": 1,
                "search_volume": 697
              },
              {
                "year": 2022,
                "month": 11,
                "day": 1,
                "search_volume": 722
              },
              {
                "year": 2022,
                "month": 10,
                "day": 1,
                "search_volume": 719
              },
              {
                "year": 2022,
                "month": 9,
                "day": 1,
                "search_volume": 660
              },
              {
                "year": 2022,
                "month": 8,
                "day": 1,
                "search_volume": 589
              },
              {
                "year": 2022,
                "month": 7,
                "day": 1,
                "search_volume": 684
              }
            ]
          }
        }
      ]
    }
  ]
}